unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const pn=4;
      scale=20;
      pontSz=200;
var
  Form1: TForm1;
  kp   : Array [1..pn] of TPoint;   //A pontok tmbje
  xk, yk, j     : integer;
  kivalasztott  : integer;          //A kivlasztott pont mozgathat
             u  : real;


Implementation
{$R *.DFM}

Function sk(x : real; n : word) : real;
var
  nt     : word;
  res    : real;
begin
 res    := 1;
 for nt := 1 to n do
     res:= res * x;
     sk := res;
end;

Function xp(i, j: integer): integer;
begin
      u:=j/PontSz;
       if i=0 then
          xp:=round(((6-sk(u,3))*kp[1].x+sk(u,3)*kp[2].x)/6)
        else if i=1 then
          xp:=round(((5-3*u-3*sk(u,2)+2*sk(u,3))*kp[1].x+(1+3*u+3*sk(u,2)-3*sk(u,3))*kp[2].x+sk(u,3)*kp[3].x)/6)
        else if i=pn-1 then
          xp:=round(((1-3*u+3*sk(u,2)-sk(u,3))*kp[pn-2].x+(4-6*sk(u,2)+3*sk(u,3))*kp[pn-1].x+(1+3*u+3*sk(u,2)-2*sk(u,3))*kp[pn].x)/6)
        else if i=pn then
          xp:=round(((1-3*u+3*sk(u,2)-sk(u,3))*kp[pn-1].x+(5+3*u-3*sk(u,2)+sk(u,3))*kp[pn].x)/6)
        else
          xp:=round(((1-3*u+3*sk(u,2)-sk(u,3))*kp[i-1].x+(4-6*sk(u,2)+3*sk(u,3))*kp[i].x+(1+3*u+3*sk(u,2)-3*sk(u,3))*kp[i+1].x+sk(u,3)*kp[i+2].x)/6);
end;

Function yp(i, j: integer): integer;
begin
      u:=j/PontSz;
       if i=0 then
          yp:=round(((6-sk(u,3))*kp[1].y+sk(u,3)*kp[2].y)/6)
        else if i=1 then
          yp:=round(((5-3*u-3*sk(u,2)+2*sk(u,3))*kp[1].y+(1+3*u+3*sk(u,2)-3*sk(u,3))*kp[2].y+sk(u,3)*kp[3].y)/6)
        else if i=pn-1 then
          yp:=round(((1-3*u+3*sk(u,2)-sk(u,3))*kp[pn-2].y+(4-6*sk(u,2)+3*sk(u,3))*kp[pn-1].y+(1+3*u+3*sk(u,2)-2*sk(u,3))*kp[pn].y)/6)
        else if i=pn then
          yp:=round(((1-3*u+3*sk(u,2)-sk(u,3))*kp[pn-1].y+(5+3*u-3*sk(u,2)+sk(u,3))*kp[pn].y)/6)
        else
          yp:=round(((1-3*u+3*sk(u,2)-sk(u,3))*kp[i-1].y+(4-6*sk(u,2)+3*sk(u,3))*kp[i].y+(1+3*u+3*sk(u,2)-3*sk(u,3))*kp[i+1].y+sk(u,3)*kp[i+2].y)/6);
end;

Function Pontkeres(x,y:integer):integer;
// A fggvny kikeresi az x,y ponthoz legkzelebbi sarokpontot
var tav,tav1,tav2,tav12:real;
    i:integer;
begin
   tav:=10000;
   Pontkeres:=-1;
   for i:=1 to pn do
     begin
       tav1:=(kp[i].x-x);
       tav2:=(kp[i].y-y);
       tav1:=tav1*tav1;
       tav2:=tav2*tav2;
       tav12:=tav1+tav2;
       if tav12<tav then
         begin
           tav:=tav12;
           Pontkeres:=i;
         end;
     end;
end;
procedure TForm1.FormCreate(Sender: TObject);

begin
   // Ltrehozzuk az alapbra pontjait
   xk:=ClientWidth  div 2; yk:=ClientHeight div 2;
   kp[1].x:=xk+(-9*scale); kp[1].y:=yk-(0*scale) ;
   kp[2].x:=xk+(-4*scale); kp[2].y:=yk-(0*scale) ;
   kp[3].x:=xk+(4*scale);  kp[3].y:=yk-(0*scale) ;
   kp[4].x:=xk+(9*scale);  kp[4].y:=yk-(0*scale) ;
   kivalasztott:=-1;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i:word;
begin
  Canvas.pen.color:=clBlack;
  Canvas.Moveto(kp[1].x,kp[1].y);
  For i:=1 to pn do for j:=1 to PontSz do Canvas.LineTo(xp(i,j),  yp(i,j));
  For i:=1 to pn do Canvas.Ellipse(kp[i].x-4,kp[i].y-4,kp[i].x+5,kp[i].y+5);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //Gombnyomssal pontot vlasztunk
  kivalasztott:=Pontkeres(x,y);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Ha elengedjk az egrgombot nincs kivlasztott pont
  kivalasztott:=-1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   // Ha van kivlasztott pont (lenyomott egrgomb), akkor az mozog
   if (kivalasztott>-1) then
     begin
  // Az elso s az utolso pont rogzitett
       if (kivalasztott<>0) and (kivalasztott<>pn+1) then
        begin
         kp[kivalasztott].x:=x;
         kp[kivalasztott].y:=y;
        end;
      Refresh;
     end;
end;

End.
