unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const pn=4;
      scale=20;
      finomsag=0.1;
var
  Form1: TForm1;
  kp   : Array [1..pn] of TPoint;   //A pontok tmbje
  xk, yk, j,i       : integer;
  kivalasztott    : integer;          //A kivlasztott pont mozgathat
  xy,xx,x,y,sx,sy : integer;
  b,m             : real;



Implementation
{$R *.DFM}

Function f(x:real):real;
  begin
    f:=(m*x)+b;    //Egyenes egyenlete
  end;

Procedure LinearisReg;
begin
  xy:=0; xx:=0; x:=0; y:=0;
  For i:=1 to pn do xy:=xy+(kp[i].x*kp[i].y); //Az xy szorzat szummaja
  For i:=1 to pn do xx:=xx+(kp[i].x*kp[i].x); //Az xx szorzat szummaja
              For i:=1 to pn do x:=x+kp[i].x; //Az x szummaja
              For i:=1 to pn do y:=y+kp[i].y; //Az y szummaja

  sx:=round(x/pn);  //Sulypont x koordinataja
  sy:=round(y/pn);  //Sulypont y koordinataja

  b:=((x*xy)-(xx*y))/((x*x)-(xx*pn));
  m:=(y-pn*b)/x;
end;

Function Pontkeres(x,y:integer):integer;
// A fggvny kikeresi az x,y ponthoz legkzelebbi sarokpontot
var tav,tav1,tav2,tav12:real;
    i:integer;
begin
   tav:=10000;
   Pontkeres:=-1;
   for i:=1 to pn do
     begin
       tav1:=(kp[i].x-x);
       tav2:=(kp[i].y-y);
       tav1:=tav1*tav1;
       tav2:=tav2*tav2;
       tav12:=tav1+tav2;
       if tav12<tav then
         begin
           tav:=tav12;
           Pontkeres:=i;
         end;
     end;
end;
procedure TForm1.FormCreate(Sender: TObject);

begin
   // Ltrehozzuk az alapbra pontjait
   xk:=ClientWidth  div 2; yk:=ClientHeight div 2;
   kp[1].x:=xk+(-9*scale); kp[1].y:=yk-(0*scale) ;
   kp[2].x:=xk+(-4*scale); kp[2].y:=yk-(0*scale) ;
   kp[3].x:=xk+(4*scale);  kp[3].y:=yk-(0*scale) ;
   kp[4].x:=xk+(9*scale);  kp[4].y:=yk-(0*scale) ;
   kivalasztott:=-1;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
ik,iv : real;
begin
    Canvas.pen.color:=clBlack;
    ik:=0;  iv:=xk*2;         LinearisReg;
    Canvas.MoveTo(round(ik),round(f(ik)));
    while ik<iv do
      begin
        Canvas.LineTo(round(ik),round(f(ik)));
        ik:=ik+finomsag;
      end;
  For i:=1 to pn do Canvas.Ellipse(kp[i].x-4,kp[i].y-4,kp[i].x+5,kp[i].y+5);
  Canvas.pen.color:=clRed; Canvas.Ellipse(sx-4,sy-4,sx+5,sy+5);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //Gombnyomssal pontot vlasztunk
  kivalasztott:=Pontkeres(x,y);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Ha elengedjk az egrgombot nincs kivlasztott pont
  kivalasztott:=-1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   // Ha van kivlasztott pont (lenyomott egrgomb), akkor az mozog
   if (kivalasztott>-1) then
     begin
  // Az elso s az utolso pont rogzitett
       if (kivalasztott<>0) and (kivalasztott<>pn+1) then
        begin
         kp[kivalasztott].x:=x;
         kp[kivalasztott].y:=y;
        end;
      Refresh;
     end;
end;

End.
