Program Lagrange_i;

Uses Graph;

Const scale=20;
      finomsag=0.01;
               pn=8;  {Kontrol Pontok szama}

Type Pont2D=record
                  X,Y : longint;
            end;
Var
    kp        : Array[1..pn] of Pont2D;  {Kontrol Pontok}
    i,j       : word;
    a,prod,sum: real;

Function ReadKey:Char; Assembler;
 asm
  xor ah,ah
  int 16h
 end;

Procedure VideoInit;
Var
  hibakod,gd,gm : integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                        writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                        halt(1);
                      end;
   end;

Function L(x:real):real;  {Lagrange interpolacio}
  begin
  sum:=0;
   for i:=1 to pn do begin
    prod:=1;   a:=1;
       for j:=1 to pn do begin
                          If i<>j then a:=(x-kp[j].x)/(kp[i].x-kp[j].x);
                          prod:=prod*a;
                         end;
        sum:=sum+(prod*kp[i].y);

   end;
    L:=sum;
  end;

Procedure F_koor;
Var i:integer;
  begin
    SetBKColor(0);
    SetColor(white);

    OutTextXY(10,10,'3Dimenzios grafika alapjai');
    OutTextXY(10,20,'Lagrange interpolci NYME');
    OutTextxy(325,10, 'y');OutTextxy(630,250,'x');
    SetColor(2);
    Line(320,0,320,480)  ; Line(0,240,640,240)   ;
    Line(317,7,320,0)    ; Line(320,0,323,7)     ;
    Line(633,236,640,240); Line(633,244,640,240) ;

    i:=0;
    while i<640 do begin
      line(i,238,i,242);
      i:=i+20;
    end;
    i:=20;
    while i<480 do begin
      line(318,i,322,i);
      i:=i+20;
    end;
end;

Procedure L_vonal(tol,ig:real);
  var elozo,i:real;
  begin
    i:=tol;  SetColor(red);
    MoveTo(320+round(scale*i),240-round(L(i)*scale));
    while i<ig do
      begin
        LineTo(320+round(scale*i),240-round(L(i)*scale));
        i:=i+finomsag;
      end;
  end;


Begin
  VideoInit;

   kp[1].x:=-5; kp[1].y:=1;
   kp[2].x:=1 ; kp[2].y:=2;
   kp[3].x:=7 ; kp[3].y:=1;
   kp[4].x:=2 ; kp[4].y:=3;
   kp[5].x:=-8; kp[5].y:=6;
   kp[6].x:=-3; kp[6].y:=5;
   kp[7].x:=9 ; kp[7].y:=2;
   kp[8].x:=-9; kp[8].y:=3;

  F_koor;  L_vonal(-9,9);
  SetFillStyle(1,yellow);
  For i:=1 to pn do FillEllipse(320+(kp[i].x*scale),240-(kp[i].y*scale),3,3);
Readkey;
CloseGraph;
End. of program