unit Hermiteu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const pn=5;
      scale=20;
      pontSz=200;
      lepeskoz=0.1;
var
  Form1: TForm1;
  kp   : Array [1..pn] of TPoint;   //A pontok tmbje
  ep   : Array [1..pn] of TPoint;   //Az erintok tmbje
  xk, yk, j, k  : integer;
  kivalasztott  : integer;            //A kivlasztott pont mozgathat
  n, w, z, k0   : real;
           ch   : char;

Implementation
{$R *.DFM}

Function sk(x : real; n : word) : real;
var
  nt     : word;
  res    : real;
begin
 res    := 1;
 for nt := 1 to n do
     res:= res * x;
     sk := res;
end;

Procedure ErintoSz; {Erinto szamitas}
begin
  case ch of
  'n':begin
          ep[1].x:=round( (kp[2].x-kp[1].x )*k0);
          ep[1].y:=round( (kp[2].y-kp[1].y )*k0);
       ep[pn].x:=round((kp[pn].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[pn].y-kp[pn-1].y)*k0);
      end;
  'z':begin
          ep[1].x:=round((kp[2].x-kp[pn].x)*k0);
          ep[1].y:=round((kp[2].y-kp[pn].y)*k0);
       ep[pn].x:=round((kp[1].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[1].y-kp[pn-1].y)*k0);
      end;
  end;

  for k:=2 to pn-1 do begin
                       ep[k].x:=round((kp[k+1].x-kp[k-1].x)*k0);
                       ep[k].y:=round((kp[k+1].y-kp[k-1].y)*k0);
                      end;
end;

function xp(i, j: integer): integer;
begin
  case ch of
  'n':begin
      n:=j/PontSz;
      xp:=round(((2*sk(n,3)-3*sk(n,2)+1)*kp[i].x+(-2*sk(n,3)+3*sk(n,2))*kp[i+1].x+
               (sk(n,3)-2*sk(n,2)+n)*ep[i].x+(sk(n,3)-sk(n,2))*ep[i+1].x));
    end;
  'z':begin
      n:=j/PontSz;
      if i=pn then
        xp:=round(((2*sk(n,3)-3*sk(n,2)+1)*kp[pn].x+(-2*sk(n,3)+3*sk(n,2))*kp[1].x+
                   (sk(n,3)-2*sk(n,2)+n)*ep[pn].x+(sk(n,3)-sk(n,2))*ep[1].x))
      else
        xp:=round(((2*sk(n,3)-3*sk(n,2)+1)*kp[i].x+(-2*sk(n,3)+3*sk(n,2))*kp[i+1].x+
                  (sk(n,3)-2*sk(n,2)+n)*ep[i].x+(sk(n,3)-sk(n,2))*ep[i+1].x));
    end;
  end;
end;

function yp(i, j: integer): integer;
begin
  case ch of
  'n':begin
     n:=j/PontSz;
     yp:=round(((2*sk(n,3)-3*sk(n,2)+1)*kp[i].y+(-2*sk(n,3)+3*sk(n,2))*kp[i+1].y+
               (sk(n,3)-2*sk(n,2)+n)*ep[i].y+(sk(n,3)-sk(n,2))*ep[i+1].y));
    end;
  'z':begin
      n:=j/PontSz;
      if i=pn then
      yp:=round(((2*sk(n,3)-3*sk(n,2)+1)*kp[pn].y+(-2*sk(n,3)+3*sk(n,2))*kp[1].y+
                   (sk(n,3)-2*sk(n,2)+n)*ep[pn].y+(sk(n,3)-sk(n,2))*ep[1].y))
      else
      yp:=round(((2*sk(n,3)-3*sk(n,2)+1)*kp[i].y+(-2*sk(n,3)+3*sk(n,2))*kp[i+1].y+
                  (sk(n,3)-2*sk(n,2)+n)*ep[i].y+(sk(n,3)-sk(n,2))*ep[i+1].y));
    end;
  end;
end;


Function Pontkeres(x,y:integer):integer;
// A fggvny kikeresi az x,y ponthoz legkzelebbi sarokpontot
var tav,tav1,tav2,tav12:real;
    i:integer;
begin
   tav:=10000;
   Pontkeres:=-1;
   for i:=1 to pn do
     begin
       tav1:=(kp[i].x-x);
       tav2:=(kp[i].y-y);
       tav1:=tav1*tav1;
       tav2:=tav2*tav2;
       tav12:=tav1+tav2;
       if tav12<tav then
         begin
           tav:=tav12;
           Pontkeres:=i;
         end;
     end;
end;
procedure TForm1.FormCreate(Sender: TObject);

begin
   // Ltrehozzuk az alapbra pontjait
   xk:=ClientWidth  div 2; yk:=ClientHeight div 2;
   kp[1].x:=xk+(-9*scale); kp[1].y:=yk-(0*scale) ;
   kp[2].x:=xk+(-4*scale); kp[2].y:=yk-(0*scale) ;
   kp[3].x:=xk+(0*scale);  kp[3].y:=yk-(0*scale) ;
   kp[4].x:=xk+(4*scale);  kp[4].y:=yk-(0*scale) ;
   kp[5].x:=xk+(9*scale);  kp[5].y:=yk-(0*scale) ;
   kivalasztott:=-1;       Ch:='n';      k0:=0.9 ;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i:word;
begin
  Canvas.pen.color:=clBlack;           ErintoSz;
  if ch='n' then Canvas.Moveto(kp[1].x,kp[1].y);
  if ch='z' then Canvas.Moveto(xp(1,0),yp(1,0));
  for i:=1 to pn-1 do for j:=1 to PontSz do Canvas.Lineto(xp(i,j),yp(i,j));
  if ch='z' then      for j:=1 to PontSz do Canvas.Lineto(xp(pn,j),yp(pn,j));

  For i:=1 to pn do Canvas.Ellipse(kp[i].x-4,kp[i].y-4,kp[i].x+5,kp[i].y+5)
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //Gombnyomssal pontot vlasztunk
  kivalasztott:=Pontkeres(x,y);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Ha elengedjk az egrgombot nincs kivlasztott pont
  kivalasztott:=-1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   // Ha van kivlasztott pont (lenyomott egrgomb), akkor az mozog
   if (kivalasztott>-1) then
     begin
  // Az elso s az utolso pont rogzitett
       if (kivalasztott<>0) and (kivalasztott<>pn+1) then
        begin
         kp[kivalasztott].x:=x;
         kp[kivalasztott].y:=y;
        end;
      Refresh;
     end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  Case Key of
   'n':ch:=Key;
   'z':ch:=Key;
   'p':k0:=k0+lepeskoz;
   'm':k0:=k0-lepeskoz;
   end;
  Refresh;
end;

End.
