unit lagrangu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const pn=5;
      scale=20;
      lepeskoz=0.1;
var
  Form1: TForm1;
  kp   : Array [1..pn] of TPoint;   //A pontok tmbje
  xk, yk      : integer;
  a,sum,prod  : real;
  kivalasztott: integer;            //A kivlasztott pont mozgathat


implementation
{$R *.DFM}

Function L(x:real):real;
Var i,j : word;
  begin
  sum:=0;
   for i:=1 to pn do begin
    prod:=1;   a:=1;
       for j:=1 to pn do begin
                          If (kp[i].x-kp[j].x)<>0 then
                            If i<>j then a:=(x-kp[j].x)/(kp[i].x-kp[j].x);
                            prod:=prod*a;
                         end;
        sum:=sum+(prod*kp[i].y);
   end;
    L:=sum;
  end;

Function Pontkeres(x,y:integer):integer;
// A fggvny kikeresi az x,y ponthoz legkzelebbi sarokpontot
var tav,tav1,tav2,tav12:real;
    i:integer;
begin
   tav:=10000;
   Pontkeres:=-1;
   for i:=1 to pn do
     begin
       tav1:=(kp[i].x-x);
       tav2:=(kp[i].y-y);
       tav1:=tav1*tav1;
       tav2:=tav2*tav2;
       tav12:=tav1+tav2;
       if tav12<tav then
         begin
           tav:=tav12;
           Pontkeres:=i;
         end;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   // Ltrehozzuk az alapbra pontjait
   xk:=ClientWidth  div 2;
   yk:=ClientHeight div 2;
   kp[1].x:=xk+(-9*scale); kp[1].y:=yk-(0*scale);
   kp[2].x:=xk+(-4*scale); kp[2].y:=yk-(0*scale);
   kp[3].x:=xk+( 0*scale); kp[3].y:=yk-(0*scale);
   kp[4].x:=xk+( 4*scale); kp[4].y:=yk-(0*scale);
   kp[5].x:=xk+( 9*scale); kp[5].y:=yk-(0*scale);
   kivalasztott:=-1;
end;

procedure TForm1.FormPaint(Sender: TObject);
var ik,iv:real;
    i    :word;
begin
    ik:=kp[1].x; iv:=kp[5].x;
    Canvas.pen.color:=clBlack;
    Canvas.MoveTo(round(ik),round(L(ik)));
    while ik<iv do
      begin
        Canvas.LineTo(round(ik),round(L(ik)));
        ik:=ik+lepeskoz;
      end;
  For i:=1 to pn do Canvas.Ellipse(kp[i].x-4,kp[i].y-4,kp[i].x+5,kp[i].y+5)
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //Gombnyomssal pontot vlasztunk
  kivalasztott:=Pontkeres(x,y);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Ha elengedjk az egrgombot nincs kivlasztott pont
  kivalasztott:=-1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   // Ha van lenyomott egrgomb, akkor az mozog
   if (kivalasztott>-1) then begin
   // Az elso s az utolso pont rogzitett
       if (kivalasztott<>1) and (kivalasztott<>pn) then
        begin
         kp[kivalasztott].x:=x;
         kp[kivalasztott].y:=y;
        end;
      Refresh;
     end;
end;

End.
