{$N+}
Program Bezier2;
{
             
             ۱
                                                   ۱
                      Bezier approximci          ۱
                                                   ۱
             ۱
             ۱
               
}
Uses Graph;

Function ReadKey:Char; Assembler;
 asm
  xor ah,ah
  int 16h
 end;

Procedure DrawBezierCurve(px1,py1,px2,py2,px3,py3,px4,py4,count : integer);

Function power(x : real; n : word) : real;
var
  nt     : word;
  result : real;
begin
 result := 1;
 for nt := 1 to n do
     result := result * x;
 power := result;
end;

Procedure Bezier(t : real; var x, y : integer);
begin
 x := round(power(1 - t, 3) * px1 + 3 * t * power(1 - t, 2) * px2 +
                     3 * t * t * (1 - t) * px3 + power(t, 3) * px4);
 y := round(power(1 - t, 3) * py1 + 3 * t * power(1 - t, 2) * py2 +
                     3 * t * t * (1 - t) * py3 + power(t, 3) * py4);
end;

var
 resolution,t : real;
 xc, yc       : integer;
begin
        if count = 0 then exit;
           resolution:=1/count;

        MoveTo(px1,py1);
        t := 0;
        while t < 1 do begin
           Bezier(t, xc, yc);
              LineTo(xc, yc);
              t := t + resolution;
        end;
        LineTo(px4,py4);
end;

Var
  Gd, Gm, I : integer;

Begin
    Gd:=Detect;
    InitGraph (Gd,Gm,'');
    OutTextXY(10,10,'Bizer approximci');
DrawBezierCurve(43,123,345,10,530,423,245,345,40);
Readkey;
End. of program
