{$N+}
Program LinReg;

Uses Graph;

Const         pn=6;
          Scale=20;
      Finomsag=0.1;

Type Pont2D=record
                  X,Y : longint;
            end;
Var
   i               : word;
   kp              : Array[1..pn] of Pont2D;
   xy,xx,x,y,sx,sy : integer;
   b,m             : real;

Function ReadKey:Char; Assembler;
 asm
  xor ah,ah
  int 16h
 end;

Procedure VideoInit;
Var hibakod,gd,gm:integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                       writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                       halt(1);
                     end;
   end;

Procedure LinearisReg;
Var
  sm,sb,s : string;
begin
  For i:=1 to pn do xy:=xy+(kp[i].x*kp[i].y); (*Az xy szorzat szummaja*)
  For i:=1 to pn do xx:=xx+(kp[i].x*kp[i].x); (*Az xx szorzat szummaja*)
              For i:=1 to pn do x:=x+kp[i].x; (*Az x szummaja*)
              For i:=1 to pn do y:=y+kp[i].y; (*Az y szummaja*)

  sx:=320+(round((x/pn)*scale));  (*Sulypont x koordinataja*)
  sy:=240-(round((y/pn)*scale));  (*Sulypont y koordinataja*)

  b:=((x*xy)-(xx*y))/((x*x)-(xx*pn));
  m:=(y-pn*b)/x;     SetColor(white);

  Str(m:4:4,sm); Str(b:4:4,sb); s:='Egyenes egyenlete: y='+sm+'*x'+'+'+sb;
  OutTextXY(10,30,s);
end;

Function f(x:real):real;
  begin
    f:=(m*x)+b;    (*Egyenes egyenlete*)
  end;

Procedure fv_vonal(tol,ig:real);
var elozo,i : real;
  begin
    LinearisReg;
    i:=tol;  SetColor(red);
    MoveTo(320+round(scale*i),240-round(f(i)*scale));
    while i<ig do
      begin
        LineTo(320+round(scale*i),240-round(f(i)*scale));
        i:=i+finomsag;
      end;
  end;

Procedure F_felulet;
Var i:integer;
   begin
    SetBKColor(0);
    SetColor(white);

    OutTextXY(10,10,'3Dimenzios grafika alapjai');
    OutTextXY(10,20,'Lineris  regresszi  NYME');
    OutTextxy(325,10, 'y');OutTextxy(630,250,'x');
                                      SetColor(2);
    Line(320,0,320,480)  ; Line(0,240,640,240)   ;
    Line(317,7,320,0)    ; Line(320,0,323,7)     ;
    Line(633,236,640,240); Line(633,244,640,240) ;

    i:=0;
    while i<640 do begin
      line(i,238,i,242);
      i:=i+scale;
    end;
    i:=20;
    while i<480 do begin
      line(318,i,322,i);
      i:=i+scale;
    end;

end;

Begin
      VideoInit;
          F_felulet;
        kp[1].x:= 1;  kp[1].y:= 2;
        kp[2].x:= 3;  kp[2].y:= 4;
        kp[3].x:= 2;  kp[3].y:= 3;
        kp[4].x:= 1;  kp[4].y:= 5;
        kp[5].x:=10;  kp[5].y:= 8;
        kp[6].x:= 6;  kp[6].y:=10;
   Fv_vonal(-10,10);
   SetColor(red);     SetFillStyle(1,yellow);  (*Kontrollpontok megjelenitese*)
   For i:=1 to pn do  FillEllipse(320+(kp[i].x*scale),240-(kp[i].y*scale),3,3);
   SetFillStyle(1,1); FillEllipse(sx,sy,3,3);  (*  Sulypont megjelenitese    *)
Readkey;
End. of program